common/urls.py
from django.urls import path
from .views import indexView, listAttributeView, editAttributeView, editPatientView


app_name = "common"


urlpatterns = [
    path('', indexView.as_view(), name='index'),
    path('edit-patient/<int:id>/', editPatientView.as_view(), name='edit-patient'),
    path('list-attribute/', listAttributeView.as_view(), name='list-attribute'),
    path('edit-attribute/<int:id>/', editAttributeView.as_view(), name='edit-attribute'),
]

conf/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('common.urls', namespace="common")),
]

common/models.py
from django.db import models
from django.contrib.postgres.fields import ArrayField, JSONField

class Attribute(models.Model):
    name = models.CharField(max_length=100, blank= False)
    active = models.BooleanField(blank=False, default=True)
    max_length = models.PositiveIntegerField(blank=False)

    @property
    def normal_name(self):
        return self.name.lower().replace(" ","_")

    def clean(self):
        super(Attribute, self).clean()
        # Implement data validation

    def __str__(self):
        return self.name

    class Meta:
        ordering = ['name']

class Patient(models.Model):
    name = models.CharField(max_length=100, blank= False)
    email = models.EmailField(blank= False)
    attributes = JSONField(blank=True, null=True)

common/forms.py
from django import forms
from .models import Attribute, Patient


class AttributeForm(forms.ModelForm):
    class Meta:
        model = Attribute
        fields = ["name", "active", "max_length"]


class PatientForm(forms.ModelForm):
    class Meta:
        model = Patient
        exclude = ["attributes"]


class PattientAttributeForm(forms.Form):

    def __init__(self, *args, **kwargs):
        attributes = Attribute.objects.filter(active=True)
        instance = kwargs.pop("instance",None)
        super().__init__(*args, **kwargs)

        for attribute in attributes:
            field_name = attribute.normal_name
            field = forms.CharField(widget=forms.TextInput(
                attrs={'style': ''}), required=False)
            self.fields[field_name] = field


        for field_name, field in self.fields.items():
            if instance != None and instance.attributes != None:
                field.initial = instance.attributes.get(field_name,"")

            field.widget.attrs['class'] = 'widget-control'

common/views.py
from django.shortcuts import render, HttpResponseRedirect, redirect, get_object_or_404
from django.urls import reverse
from django.views.generic import (
    CreateView, UpdateView, DetailView, TemplateView, View, DeleteView)
from .forms import AttributeForm, PatientForm, PattientAttributeForm
from .models import Attribute, Patient


class indexView(TemplateView):
    template_name = "index.html"

    def get_context_data(self, **kwargs):
        context = super(indexView, self).get_context_data(**kwargs)
        patients = Patient.objects.all()
        attributes = Attribute.objects.filter(active=True)

        rows = []
        for patient in patients:
            row = [patient.name, patient.email]
            for attribute in attributes:
                key = attribute.normal_name
                value = patient.attributes.get(key, "")
                row.append(value)

            row = {"data":row, "id":patient.id}
            rows.append(row)
        context["rows"] = rows
        context["attributes"] = attributes
        return context

    def post(self, request, *args, **kwargs):
        form = PatientForm(request.POST)
        attribute_form = PattientAttributeForm(request.POST)
        if form.is_valid() and attribute_form.is_valid():
            patient = form.save(commit=False)
            patient_attribute = attribute_form.cleaned_data
            patient.attributes = patient_attribute
            patient.save()
            return redirect(reverse("common:index"))
        else:
            context = self.get_context_data()
            context["form"] = form
            context["attribute_form"] = attribute_form
            return self.render_to_response(context=context)

    def get(self, request, *args, **kwargs):
        context = self.get_context_data(**kwargs)
        context["form"] = PatientForm()
        context["attribute_form"] = PattientAttributeForm()
        return self.render_to_response(context=context)


class editPatientView(TemplateView):
    template_name = "editPatient.html"

    def post(self, request, *args, **kwargs):
        patient = get_object_or_404(
            Patient, id=kwargs.get("id"))
        form = PatientForm(request.POST, instance=patient)
        attribute_form = PattientAttributeForm(request.POST, instance=patient)
        if form.is_valid() and attribute_form.is_valid():
            patient = form.save(commit=False)
            patient_attribute = attribute_form.cleaned_data
            patient.attributes = patient_attribute
            patient.save()
            return redirect(reverse("common:index"))
        else:
            context = self.get_context_data()
            context["form"] = form
            context["attribute_form"] = attribute_form
            return self.render_to_response(context=context)

    def get(self, request, *args, **kwargs):
        context = super(editPatientView, self).get_context_data(**kwargs)
        patient = get_object_or_404(
            Patient, id=kwargs.get("id"))
        context["form"] = PatientForm(instance=patient)
        context["attribute_form"] = PattientAttributeForm(instance=patient)
        return self.render_to_response(context=context)


class listAttributeView(TemplateView):
    template_name = "listAttribute.html"

    def get_context_data(self, **kwargs):
        context = super(listAttributeView, self).get_context_data(**kwargs)
        context["attributes"] = Attribute.objects.all()
        return context

    def post(self, request, *args, **kwargs):
        form = AttributeForm(request.POST)
        if form.is_valid():
            attribute = form.save()
            return redirect(reverse("common:list-attribute"))
        else:
            context = self.get_context_data()
            context["form"] = form
            return self.render_to_response(context=context)

    def get(self, request, *args, **kwargs):
        context = self.get_context_data(**kwargs)
        context["form"] = AttributeForm()
        return self.render_to_response(context=context)


class editAttributeView(TemplateView):
    template_name = "editAttribute.html"

    def post(self, request, *args, **kwargs):
        attribute = get_object_or_404(
            Attribute, id=kwargs.get("id"))
        old_attribute_name = attribute.normal_name
        form = AttributeForm(request.POST, instance=attribute)
        if form.is_valid():
            attribute = form.save()
            if 'name' in form.changed_data:
                patients = Patient.objects.all()
                for patient in patients:
                    if patient.attributes.get(old_attribute_name, '') == '':
                        patient.attributes[attribute.normal_name] = ''
                    elif patient.attributes.get(old_attribute_name, '') != '':
                        patient.attributes[attribute.normal_name] = patient.attributes.pop(
                            old_attribute_name)
                    patient.save()
            return redirect(reverse("common:list-attribute"))
        else:
            context = self.get_context_data()
            context["form"] = form
            return self.render_to_response(context=context)

    def get(self, request, *args, **kwargs):
        context = super(editAttributeView, self).get_context_data(**kwargs)
        attribute = get_object_or_404(
            Attribute, id=kwargs.get("id"))
        context["form"] = AttributeForm(instance=attribute)
        return self.render_to_response(context=context)

common/templates/editAttribute.html
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <title>edit attributes</title>
</head>
<body>
    <h1>Edit Attribute</h1>
    <form method="POST">
        {% csrf_token %}
        {{form.as_p}}
        <button type="submit" class="btn btn-primary">Simpan</button>
    </form>
    
</body>
<script src="https://code.jquery.com/jquery-3.4.1.slim.min.js"
    integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n"
    crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
    integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
    crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"
    integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6"
    crossorigin="anonymous"></script>
</html>

common/templates/editPatient.html
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <title>edit patient</title>
</head>

<body>
    <h1>Edit Patient</h1>
    <form method="POST">
        {% csrf_token %}
        {{ form.as_p }}
        {{ attribute_form.as_p }}
        <button type="submit" class="btn btn-primary">Simpan</button>
    </form>

</body>
<script src="https://code.jquery.com/jquery-3.4.1.slim.min.js"
    integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n"
    crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
    integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
    crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"
    integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6"
    crossorigin="anonymous"></script>

</html>

common/templates/index.html
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <title>Index</title>
</head>

<body>
    <h1>Homepage</h1>
    <a href="{% url 'common:index' %}">Home</a>
    <a href="{% url 'common:list-attribute' %}">list of attribute</a>
    <h1>Add new Patient</h1>
    <form method="POST">
        {% csrf_token %}
        {{ form.as_p }}
        {{ attribute_form.as_p }}
        <button type="submit" class="btn btn-primary">Simpan</button>
    </form>
    <br>
    <br>
    <h1>List of Patient</h1>
    <table>
        <thead>
            <th>Name</th>
            <th>Email</th>
            {% for attribute in attributes %}
            <th>{{attribute.name}}</th>
            {% endfor %}
            <th>Action</th>
        </thead>
        <tbody>
            {% for data in rows %}
            <tr>
                {% for cell in data.data %}
                <td>{{cell}}</td>
                {% endfor %}
                <td><a href="{% url 'common:edit-patient' data.id %}" class="btn btn-warning">Ubah</a></td>
            </tr>
            {% endfor %}
        </tbody>
    </table>
</body>
<script src="https://code.jquery.com/jquery-3.4.1.slim.min.js"
    integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n"
    crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
    integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
    crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"
    integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6"
    crossorigin="anonymous"></script>

</html>

common/templates/listAttribute.html
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <title>list of attributes</title>
</head>

<body>
    <h1>Homepage</h1>
    <a href="{% url 'common:index' %}">Home</a>
    <a href="{% url 'common:list-attribute' %}">list of attribute</a>
    <h1>Add new Attribute</h1>
    <form method="POST">
        {% csrf_token %}
        {{form.as_p}}
        <button type="submit" class="btn btn-primary">Simpan</button>
    </form>
    <br>
    <br>
    <h1>List of Attributes</h1>
    <table>
        <thead>
            <th>Name</th>
            <th>Active</th>
            <th>Max Length</th>
            <th>Action</th>
        </thead>
        <tbody>
            {% for attribute in attributes %}
            <tr>
                <td>{{attribute.name}}</td>
                <td>{{attribute.active}}</td>
                <td>{{attribute.max_length}}</td>
                <td><a href="{% url 'common:edit-attribute' attribute.id %} " class="btn btn-warning">Ubah</a></td>
            </tr>
            {% endfor %}
        </tbody>
    </table>
</body>
<script src="https://code.jquery.com/jquery-3.4.1.slim.min.js"
    integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n"
    crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
    integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
    crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"
    integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6"
    crossorigin="anonymous"></script>
</html>